## nvidia-graphics-drivers-535 535.54.03

=== src/nvidia/Makefile ===
###########################################################################
# Makefile for nv-kernel.o
###########################################################################

NV_MODULE_LOGGING_NAME ?= nvidia

VERSION_MK_DIR = ../../

include ../../utils.mk

include srcs.mk

##############################################################################
# Helper functions to determine the compiler type
##############################################################################
GET_COMPILER_TYPE = \
  $(shell $(VERSION_MK_DIR)/nv-compiler.sh type $(1))
##############################################################################

# The source files for nv-kernel.o are all SRCS and SRCS_CXX defined in srcs.mk,
# and the NVIDIA ID string
ALL_SRCS = $(SRCS) $(SRCS_CXX)
ALL_SRCS += $(NVIDSTRING)

SRC_COMMON = ../common
CONDITIONAL_CFLAGS :=

CFLAGS += -include $(SRC_COMMON)/sdk/nvidia/inc/cpuopsys.h

CFLAGS += -I kernel/inc
CFLAGS += -I interface
CFLAGS += -I $(SRC_COMMON)/sdk/nvidia/inc
CFLAGS += -I $(SRC_COMMON)/sdk/nvidia/inc/hw
CFLAGS += -I arch/nvalloc/common/inc
CFLAGS += -I arch/nvalloc/common/inc/gsp
CFLAGS += -I arch/nvalloc/common/inc/deprecated
CFLAGS += -I arch/nvalloc/unix/include
CFLAGS += -I inc
CFLAGS += -I inc/os
CFLAGS += -I $(SRC_COMMON)/shared/inc
CFLAGS += -I $(SRC_COMMON)/shared/msgq/inc
CFLAGS += -I $(SRC_COMMON)/inc

CFLAGS += -I $(SRC_COMMON)/uproc/os/libos-v2.0.0/include
CFLAGS += -I $(SRC_COMMON)/uproc/os/common/include
CFLAGS += -I $(SRC_COMMON)/uproc/os/libos-v2.0.0/debug
CFLAGS += -I $(SRC_COMMON)/inc/swref
CFLAGS += -I $(SRC_COMMON)/inc/swref/published

CFLAGS += -I generated
CFLAGS += -I $(SRC_COMMON)/nvswitch/kernel/inc
CFLAGS += -I $(SRC_COMMON)/nvswitch/interface
CFLAGS += -I $(SRC_COMMON)/nvswitch/common/inc/
CFLAGS += -I $(SRC_COMMON)/inc/displayport
CFLAGS += -I $(SRC_COMMON)/nvlink/interface/
CFLAGS += -I $(SRC_COMMON)/nvlink/inband/interface
CFLAGS += -I src/mm/uvm/interface
CFLAGS += -I inc/libraries
CFLAGS += -I src/libraries
CFLAGS += -I inc/kernel

# Libspdm source requires additional include paths and build flags.
include src/libraries/libspdm/nvidia/openspdm.mk
$(call BUILD_OBJECT_LIST,$(LIBSPDM_SOURCES)): CFLAGS += $(addprefix -I ,$(LIBSPDM_INCLUDES))
$(call BUILD_OBJECT_LIST,$(LIBSPDM_SOURCES)): CFLAGS += $(addprefix -D,$(LIBSPDM_DEFINES))

CFLAGS += -I $(SRC_COMMON)/mbedtls/include
CFLAGS += -I $(SRC_COMMON)/mbedtls/nvidia
CFLAGS += -DMBEDTLS_USER_CONFIG_FILE=\"nvrm_mbedtls_config.h\"

CFLAGS += -Werror-implicit-function-declaration
CFLAGS += -Wwrite-strings
CFLAGS += -Wundef
CFLAGS += -fno-common
CFLAGS += -ffreestanding
CFLAGS += -fno-stack-protector

ifeq ($(TARGET_ARCH),x86_64)
  CFLAGS += -msoft-float
  CFLAGS += -mno-red-zone
  CFLAGS += -mcmodel=kernel
  CFLAGS += -mno-mmx
  CFLAGS += -mno-sse
  CFLAGS += -mno-sse2
  CFLAGS += -mno-3dnow
endif

ifeq ($(TARGET_ARCH),aarch64)
  CFLAGS += -mgeneral-regs-only
  CFLAGS += -march=armv8-a
  CFLAGS += -mstrict-align
  CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -mno-outline-atomics)
endif

CFLAGS += -fno-pic

CFLAGS += -D_LANGUAGE_C
CFLAGS += -D__NO_CTYPE
CFLAGS += -DNVRM
CFLAGS += -DLOCK_VAL_ENABLED=0
CFLAGS += -DPORT_ATOMIC_64_BIT_SUPPORTED=1
CFLAGS += -DPORT_IS_KERNEL_BUILD=1
CFLAGS += -DPORT_IS_CHECKED_BUILD=1
CFLAGS += -DPORT_MODULE_atomic=1
CFLAGS += -DPORT_MODULE_core=1
CFLAGS += -DPORT_MODULE_cpu=1
CFLAGS += -DPORT_MODULE_crypto=1
CFLAGS += -DPORT_MODULE_debug=1
CFLAGS += -DPORT_MODULE_memory=1
CFLAGS += -DPORT_MODULE_safe=1
CFLAGS += -DPORT_MODULE_string=1
CFLAGS += -DPORT_MODULE_sync=1
CFLAGS += -DPORT_MODULE_thread=1
CFLAGS += -DPORT_MODULE_util=1
CFLAGS += -DPORT_MODULE_example=0
CFLAGS += -DPORT_MODULE_mmio=0
CFLAGS += -DPORT_MODULE_time=0
CFLAGS += -DRS_STANDALONE=0
CFLAGS += -DRS_STANDALONE_TEST=0
CFLAGS += -DRS_COMPATABILITY_MODE=1
CFLAGS += -DRS_PROVIDES_API_STATE=0
CFLAGS += -DNV_CONTAINERS_NO_TEMPLATES

CFLAGS += -DINCLUDE_NVLINK_LIB
CFLAGS += -DINCLUDE_NVSWITCH_LIB

CFLAGS += -DNV_PRINTF_STRINGS_ALLOWED=1
CFLAGS += -DNV_ASSERT_FAILED_USES_STRINGS=1
CFLAGS += -DPORT_ASSERT_FAILED_USES_STRINGS=1

ifeq ($(DEBUG),1)
  CFLAGS += -gsplit-dwarf
endif

# Define how to perform dead code elimination: place each symbol in its own
# section at compile time, and garbage collect unreachable sections at link
# time.  exports_link_command.txt tells the linker which symbols need to be
# exported from nv-kernel.o so the linker can determine which symbols are
# unreachable.
CFLAGS += -ffunction-sections
CFLAGS += -fdata-sections
NV_KERNEL_O_LDFLAGS += --gc-sections
EXPORTS_LINK_COMMAND = exports_link_command.txt

ifeq ($(TARGET_ARCH),x86_64)
  COMPILER_TYPE := $(call GET_COMPILER_TYPE, $(CC))
  ENDBR_SUPPORTED := $(call AS_HAS_INSTR, endbr64)

  FCF_SUPPORTED =

  #
  # GCC flags -fcf-protection=branch and -mindirect-branch=extern-thunk can
  # be used together after GCC version 9.4.0. See 
  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=93654 for details.
  # Check if GCC version is appropriate.
  #
  ifeq ($(COMPILER_TYPE),gcc)
    FCF_SUPPORTED := \
      $(shell $(VERSION_MK_DIR)/nv-compiler.sh version_is_at_least $(CC) 90400)
  endif

  #
  # Clang version 14.0.0 is required for -fcf-protection=branch to work
  # correctly. See commit
  # https://github.com/llvm/llvm-project/commit/dfcf69770bc522b9e411c66454934a37c1f35332
  #
  ifeq ($(COMPILER_TYPE),clang)
    FCF_SUPPORTED := \
      $(shell $(VERSION_MK_DIR)/nv-compiler.sh version_is_at_least $(CC) 140000)
  endif

  ifeq ($(FCF_SUPPORTED)-$(ENDBR_SUPPORTED),1-1)
    CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -fcf-protection=branch)
  endif
  CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -fno-jump-tables)
  CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -mindirect-branch-register)
  CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -mindirect-branch=thunk-extern)
endif

CFLAGS += $(CONDITIONAL_CFLAGS)

CC_ONLY_CFLAGS += --std=gnu11
CXX_ONLY_CFLAGS += --std=gnu++11

OBJS = $(call BUILD_OBJECT_LIST,$(ALL_SRCS))

# Define how to generate the NVIDIA ID string
$(eval $(call GENERATE_NVIDSTRING, \
  NVRM_ID, \
  UNIX Open Kernel Module, $(OBJS)))

# Define how to build each object file from the corresponding source file.
$(foreach src, $(ALL_SRCS), $(eval $(call DEFINE_OBJECT_RULE,TARGET,$(src))))

NV_KERNEL_O = $(OUTPUTDIR)/nv-kernel.o

.PHONY: all
all: $(NV_KERNEL_O)

LINKER_SCRIPT = nv-kernel.ld

$(NV_KERNEL_O): $(OBJS) $(EXPORTS_LINK_COMMAND) $(LINKER_SCRIPT)
	$(call quiet_cmd,LD) \
	  $(NV_KERNEL_O_LDFLAGS) \
	  -T $(LINKER_SCRIPT) \
	  -r -o $(NV_KERNEL_O) $(OBJS) @$(EXPORTS_LINK_COMMAND)
	$(call quiet_cmd,OBJCOPY) \
	  --localize-symbol=memset \
	  --localize-symbol=memcpy \
	  $@

.PHONY: clean
clean:
	$(RM) -rf $(OUTPUTDIR)

=== debian/changelog ===
nvidia-graphics-drivers-535 (535.54.03-0ubuntu1) mantic; urgency=medium

  * Initial release (LP: #2024675):
    - This replaces the 530 series.

 -- Alberto Milone <alberto.milone@canonical.com>  Mon, 26 Jun 2023 14:24:45 +0000

=== debian/control ===
Source: nvidia-graphics-drivers-535
Section: non-free/libs
Priority: optional
Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Uploaders:
 Alberto Milone <alberto.milone@canonical.com>,
Vcs-Git: git://github.com/tseliot/nvidia-graphics-drivers.git
Vcs-Browser: https://github.com/tseliot/nvidia-graphics-drivers/tree/535
Build-Depends:
 debhelper (>= 12),
 dpkg-dev (>= 1.17.11~),
 xz-utils,
 zstd,
 dkms,
 libxext6,
 po-debconf,
 dh-modaliases,
 xserver-xorg-dev (>= 2:1.4),
 libglvnd-dev,
 libkmod-dev,
 libpciaccess-dev,
 pkg-config,
 libnvidia-egl-wayland1,
 libc6,
 libx11-6,
 python3,
Standards-Version: 4.1.1
Homepage: http://www.nvidia.com
XS-Autobuild: yes

Package: nvidia-driver-535
Architecture: amd64 arm64
Depends:
 libnvidia-gl-535 (= ${binary:Version}),
 nvidia-dkms-535 (<= 535.54.03-1),
 nvidia-dkms-535 (>= 535.54.03),
 nvidia-kernel-common-535 (<= 535.54.03-1),
 nvidia-kernel-common-535 (>= 535.54.03),
 nvidia-kernel-source-535 (= ${binary:Version}),
 libnvidia-compute-535 (= ${binary:Version}),
 libnvidia-extra-535 (= ${binary:Version}),
 nvidia-compute-utils-535 (= ${binary:Version}),
 libnvidia-decode-535 (= ${binary:Version}),
 libnvidia-encode-535 (= ${binary:Version}),
 nvidia-utils-535 (= ${binary:Version}),
 xserver-xorg-video-nvidia-535 (= ${binary:Version}),
 libnvidia-cfg1-535 (= ${binary:Version}),
 libnvidia-fbc1-535 (= ${binary:Version}) [!ppc64el],
 ${misc:Depends}
Recommends:
 nvidia-settings, nvidia-prime (>= 0.8),
 libnvidia-compute-535:i386 (= ${binary:Version}) [amd64],
 libnvidia-decode-535:i386 (= ${binary:Version}) [amd64],
 libnvidia-encode-535:i386 (= ${binary:Version}) [amd64],
 libnvidia-fbc1-535:i386 (= ${binary:Version}) [amd64],
 libnvidia-gl-535:i386 (= ${binary:Version}) [amd64]
XB-Modaliases: ${modaliases}
XB-PmAliases: ${nvidia:pm-modaliases}
XB-Support: PB
Description: NVIDIA driver metapackage
 This metapackage depends on the NVIDIA binary driver and on all of its libraries,
 to provide hardware acceleration for OpenGL/GLX/EGL/GLES/Vulkan
 applications on either X11 or on Wayland.
 .
 See /usr/share/doc/nvidia-driver-535/README.txt.gz
 for a complete list of supported GPUs and PCI IDs.

Package: nvidia-kernel-source-535
Architecture: amd64 arm64
Multi-Arch: foreign
Conflicts:
 nvidia-kernel-source
Replaces:
 nvidia-kernel-source, nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
Provides:
 nvidia-kernel-source
Depends:
 ${misc:Depends}, ${shlibs:Depends}
Description: NVIDIA kernel source package
 This package provides the NVIDIA kernel source needed by the userspace
 driver.

Package: nvidia-dkms-535
Architecture: amd64 arm64
Multi-Arch: foreign
Conflicts:
 nvidia-dkms-kernel
Breaks: nvidia-kernel-source-535 (<< 390.25-0ubuntu2~)
Replaces:
 nvidia-dkms-kernel, nvidia-kernel-source-535 (<< 390.25-0ubuntu2~), nvidia-384 (<< 390.25)
Provides:
 nvidia-dkms-kernel
Depends:
 dkms,
 nvidia-kernel-source-535 (<= 535.54.03-1),
 nvidia-kernel-source-535 (>= 535.54.03),
 nvidia-kernel-common-535 (<= 535.54.03-1),
 nvidia-kernel-common-535 (>= 535.54.03),
 nvidia-firmware-535-535.54.03,
 ${misc:Depends}, ${shlibs:Depends}
Description: NVIDIA DKMS package
 This package builds the NVIDIA kernel module needed by the userspace
 driver, using DKMS.
 Provided that you have the kernel header packages installed, the kernel
 module will be built for your running kernel, and automatically rebuilt for
 any new kernel headers that are installed.

Package: nvidia-utils-535
Architecture: amd64 arm64
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Suggests:
 nvidia-driver-535,
Provides:
 nvidia-utils, nvidia-smi
Conflicts:
 nvidia-utils, nvidia-smi
Replaces:
 nvidia-utils, nvidia-smi
Description: NVIDIA driver support binaries
 This package contains supporting binaries for the NVIDIA driver.

Package: libnvidia-compute-535
Architecture: i386 amd64 arm64
Multi-Arch: same
Depends:
  ${misc:Depends}, ${shlibs:Depends}
Provides: libnvidia-compute, nvidia-opencl-icd, opencl-icd, libnvidia-ml.so.1 (= ${source:Version}),
 libcuda-5.0-1, libcuda-5.5-1, libcuda-6.0-1, libcuda-6.5-1,
 libcuda-7.0-1, libcuda-7.5-1, libcuda-8.0-1, libcuda-9.0-1,
 libcuda-9.1-1, libcuda-9.2-1, libcuda-10.0-1, libcuda-10.1-1,
 libcuda-10.2-1, libcuda-11.0-1, libcuda-11.1-1, libcuda-11.2-1,
 libcuda-11.3-1, libcuda-11.4-1, libcuda-11.5-1, libcuda-11.6-1,
 libcuda-11.7-1,
 libcuda.so.1 (= ${source:Version})
Conflicts: libnvidia-compute, nvidia-opencl-icd,
 libcuda-5.0-1, libcuda-5.5-1, libcuda-6.0-1, libcuda-6.5-1,
 libcuda-7.0-1, libcuda-7.5-1, libcuda-8.0-1, libcuda-9.0-1,
 libcuda-9.1-1, libcuda-9.2-1, libcuda-10.0-1, libcuda-10.1-1,
 libcuda-10.2-1, libcuda-11.0-1, libcuda-11.1-1, libcuda-11.2-1,
 libcuda-11.3-1, libcuda-11.4-1, libcuda-11.5-1, libcuda-11.6-1,
 libcuda-11.7-1
Replaces: libnvidia-compute, nvidia-opencl-icd, libnvidia-compute-535 (<< 390.25-0ubuntu2~),
 libcuda-5.0-1, libcuda-5.5-1, libcuda-6.0-1, libcuda-6.5-1,
 libcuda-7.0-1, libcuda-7.5-1, libcuda-8.0-1, libcuda-9.0-1,
 libcuda-9.1-1, libcuda-9.2-1, libcuda-10.0-1, libcuda-10.1-1,
 libcuda-10.2-1, libcuda-11.0-1, libcuda-11.1-1, libcuda-11.2-1,
 libcuda-11.3-1, libcuda-11.4-1, libcuda-11.5-1, libcuda-11.6-1,
 libcuda-11.7-1
Description: NVIDIA libcompute package
 This package provides a set of libraries which enable the NVIDIA driver
 to use GPUs for parallel general purpose computation through CUDA and
 OpenCL.

Package: nvidia-compute-utils-535
Architecture: amd64 arm64
Depends:
 libnvidia-compute-535, adduser,
 ${misc:Depends}, ${shlibs:Depends}
Provides: nvidia-compute-utils, nvidia-persistenced
Conflicts: nvidia-compute-utils, nvidia-persistenced
Replaces: nvidia-compute-utils, nvidia-persistenced
Description: NVIDIA compute utilities
 This package provides utility binaries for paraller general purpose
 computing use cases with the NVIDIA driver.
 .
 CUDA MPS is a feature that allows multiple CUDA processes to share a single
 GPU context. CUDA MPS should be transparent to CUDA programs.
 .
 CUDA MPS requires a device that supports Unified Virtual Address (UVA) and
 has compute capability SM 3.5 or higher.
 Pre-CUDA 4.0 APIs are not supported under CUDA MPS.

Package: nvidia-headless-no-dkms-535
Architecture: amd64 arm64
Conflicts: nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
Provides: nvidia-384
Replaces: nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
Depends:
 nvidia-kernel-common-535 (<= 535.54.03-1),
 nvidia-kernel-common-535 (>= 535.54.03),
 nvidia-kernel-source-535 (= ${binary:Version}),
 libnvidia-compute-535 (= ${binary:Version}),
 nvidia-compute-utils-535 (= ${binary:Version}),
 libnvidia-cfg1-535 (= ${binary:Version}),
 ${misc:Depends}, ${shlibs:Depends}
Description: NVIDIA headless metapackage - no DKMS
 This metapackage installs the NVIDIA driver and the libraries that enable
 parallel general purpose computation through CUDA and
 OpenCL. DKMS will not be installed, and, therefore, the kernel module
 will not be built.
 .
 Install this package if you do not need X11 or Wayland support, which is
 provided by the nvidia-driver-535 metapackage.

Package: nvidia-headless-535
Architecture: amd64 arm64
Conflicts: nvidia-headless
Provides: nvidia-headless
Replaces: nvidia-headless
Depends:
 nvidia-headless-no-dkms-535,
 nvidia-dkms-535,
 ${misc:Depends}, ${shlibs:Depends}
Description: NVIDIA headless metapackage
 This metapackage installs the NVIDIA driver and the libraries that enable
 parallel general purpose computation through CUDA and
 OpenCL.
 .
 Install this package if you do not need X11 or Wayland support, which is
 provided by the nvidia-driver-535 metapackage.

Package: nvidia-kernel-common-535
Architecture: amd64 arm64
Conflicts: nvidia-kernel-common
Provides: nvidia-kernel-common
Depends:
 ${misc:Depends}, ${shlibs:Depends}, nvidia-firmware-535-535.54.03
Replaces:
 nvidia-dkms-535 (<< 390.48-0ubuntu3~), nvidia-kernel-common
Description: Shared files used with the kernel module
 This package installs all the optional accessory files for the NVIDIA
 kernel module.
 .
 Install this package if you want to blacklist any conflicting kernel
 modules, and if you want udev to load the the NVIDIA kernel modules,
 and to create the uvm devices automatically.

Package: nvidia-firmware-535-535.54.03
Architecture: amd64 arm64
Depends:
 ${misc:Depends}
Description: Firmware files used by the kernel module
 This package installs required firmware files for the NVIDIA kernel
 module.

Package: libnvidia-gl-535
Architecture: i386 amd64 arm64
Multi-Arch: same
Conflicts: libnvidia-gl
Replaces: libnvidia-gl, nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
Provides: libnvidia-gl, libglx-vendor, libegl-vendor
Depends:
 libnvidia-common-535, ${misc:Depends}, ${shlibs:Depends}
Description: NVIDIA OpenGL/GLX/EGL/GLES GLVND libraries and Vulkan ICD
 This package provides the NVIDIA OpenGL/GLX/EGL/GLES libraries and the
 Vulkan ICD.

Package: libnvidia-common-535
Architecture: all
Multi-Arch: foreign
Breaks: libnvidia-gl-535 (<< 390.25-0ubuntu2~)
Conflicts: libnvidia-common
Replaces: libnvidia-common, libnvidia-gl-535 (<< 390.25-0ubuntu2~)
Provides: libnvidia-common
Depends:
 ${misc:Depends}, ${shlibs:Depends}
Description: Shared files used by the NVIDIA libraries
 This package provides a set of files that are required by the NVIDIA
 libraries.

Package: libnvidia-extra-535
Architecture: i386 amd64 arm64
Multi-Arch: same
Breaks: libnvidia-common-535 (<< 440.64-0ubuntu3~)
Conflicts: libnvidia-extra
Replaces: libnvidia-extra, libnvidia-common-535 (<< 440.64-0ubuntu3~)
Provides: libnvidia-extra
Depends:
 ${misc:Depends}, ${shlibs:Depends}
Description: Extra libraries for the NVIDIA driver
 This package provides an additional set of libraries to be used with
 the NVIDIA driver.

Package: xserver-xorg-video-nvidia-535
Section: non-free/x11
Architecture: amd64 arm64
Depends:
 libnvidia-cfg1-535 (= ${binary:Version}),
 ${nvidia:xorgDepends},
 ${shlibs:Depends}, ${misc:Depends}
Conflicts: xorg-driver-binary, nvidia-driver-binary
Replaces: xorg-driver-binary, nvidia-driver-binary
Provides:
 xorg-driver-binary, nvidia-driver-binary,
 ${nvidia:xorgProvides}
Description: NVIDIA binary Xorg driver
 The NVIDIA binary driver provides optimized hardware acceleration of
 OpenGL/GLX/EGL/GLES applications via a direct-rendering X Server
 for graphics cards using NVIDIA chip sets.
 .
 See /usr/share/doc/nvidia-driver-535/README.txt.gz
 for a complete list of supported GPUs and PCI IDs.

Package: libnvidia-cfg1-535
Architecture: amd64 arm64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Provides:
 libnvidia-cfg1-any,
Conflicts:
 libnvidia-cfg1-any,
Replaces:
 libnvidia-cfg1-any,
Description: NVIDIA binary OpenGL/GLX configuration library
 The NVIDIA binary driver provides optimized hardware acceleration of
 OpenGL/GLX/EGL/GLES applications via a direct-rendering X Server
 for graphics cards using NVIDIA chip sets.
 .
 This package contains the libnvidia-cfg.so.1 runtime library.

Package: libnvidia-fbc1-535
Architecture: i386 amd64 arm64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
# ${nvidia}-alternative (= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends}
Provides:
 libnvidia-fbc1,
Conflicts:
 libnvidia-fbc1,
Replaces:
 libnvidia-fbc1,
Description: NVIDIA OpenGL-based Framebuffer Capture runtime library
 The NVIDIA OpenGL-based Framebuffer Capture (NvFBCOpenGL) library provides
 a high performance, low latency interface to capture and optionally encode an
 OpenGL framebuffer. NvFBCOpenGL is a private API that is only available to
 approved partners for use in remote graphics scenarios.
 .
 This package contains the NvFBCOpenGL runtime library.

Package: libnvidia-decode-535
Architecture: i386 amd64 arm64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 libnvidia-compute-535 (= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends}
Conflicts:
 libnvidia-decode,
Replaces:
 libnvidia-decode,
Provides:

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export NO_DOC_PKG_MANGLE=1

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

include debian/rules.defs
XORG_ABI_LIST		?=
XORG_BOUND		?=

version			= $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e's/.*\+really\.//')
debian_version	= $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e's/.*\+really\.//')
NVIDIA_RELEASE   = $(version)
version_major		 = $(firstword $(subst ., ,$(version)))

# system libdir
libdir			?= usr/lib/$(DEB_HOST_MULTIARCH)

flavour := $(version_major)
pkg_meta         := nvidia-driver-$(flavour)
pkg_meta_open    := $(pkg_meta)-open
pkg_driver       := nvidia-$(flavour)
xorg_driver      := xserver-xorg-video-nvidia-$(flavour)
#pkg_module       := $(shell echo "$(pkg_driver)" | sed s/\-/_/g)
pkg_module       := nvidia
pkg_kernel       := nvidia-kernel-$(flavour)

ifeq ($(DEB_HOST_ARCH),amd64)
DKMS_disabled_modules :=
amd64_only :=
amd64_excluded := \#
else
amd64_only := \#
amd64_excluded :=
endif

ifeq ($(DEB_HOST_ARCH),i386)
DKMS_disabled_modules := nvidia-uvm
i386_only :=
i386_excluded := \#
else
i386_only := \#
i386_excluded :=
endif

ifeq ($(DEB_HOST_ARCH),armhf)
DKMS_disabled_modules := nvidia-uvm
armhf_only :=
armhf_excluded := \#
else
armhf_only := \#
armhf_excluded :=
endif

ifeq ($(DEB_HOST_ARCH),arm64)
DKMS_disabled_modules :=
arm64_only :=
arm64_excluded := \#
else
arm64_only := \#
arm64_excluded :=
endif

ifeq ($(DEB_HOST_ARCH),ppc64el)
DKMS_disabled_modules :=
ppc64el_only :=
ppc64el_excluded := \#
else
ppc64el_only := \#
ppc64el_excluded :=
endif

# i386 binaries are shipped in amd64
# Or could use ARCH_LIST to unpack all arches
ifeq ($(DEB_HOST_ARCH),i386)
unpack-stamp: NVIDIA-Linux-amd64
else
unpack-stamp: NVIDIA-Linux-$(DEB_HOST_ARCH)
endif

comma		 = ,
xorg_depends	 = $(foreach abi, $(XORG_ABI_LIST), xorg-video-abi-$(abi) |)
xorg_depends	+= $(comma) xserver-xorg-core $(XORG_BOUND)
xorg_provides	 = xorg-driver-video


.PHONY: prepare patch
prepare: unpack-stamp compare-copyright-license
patch: prepare

NVIDIA-Linux-%:
	sh $*/${NVIDIA_FILENAME_$*} --extract-only
	ln -s ${NVIDIA_DIRNAME_$*} $@
	ln -s $@ NVIDIA-Linux
	#gunzip $@/*.1.gz

# Unpack all architectures, we may need files from all of them.
unpack-stamp:
	dh_testdir
	#QUILT_PATCHES=debian/patches QUILT_SERIES=series-postunpack quilt --quiltrc /dev/null push -a || test $$? = 2
	ls -al
	touch $@

# Reformat the LICENSE to the format needed for debian/copyright.
LICENSE.txt: unpack-stamp
	sed -e 's/^ *//; s/ *$$//; s/^$$/./; s/^/ /;' NVIDIA-Linux/LICENSE > $@

# Compare the license in debian/copyright with the LICENSE shipped in the archive.
compare-copyright-license: LICENSE.txt
	sed -e '1,/^License: NVIDIA-graphics-drivers/d; 1,/^License: NVIDIA-graphics-drivers$$/d; /^$$\|^Comment:$$/,$$d; /^ \.$$/d' debian/copyright > copyright.tmp
	sed -e '/^ \.$$/d' LICENSE.txt > LICENSE.tmp
	diff -w copyright.tmp LICENSE.tmp
	rm -f copyright.tmp LICENSE.tmp

build-device-create:
	rm -f $(CURDIR)/debian/device-create/ub-device-create
	cd $(CURDIR)/debian/device-create/ && $(MAKE) all || exit 1
	@echo "ub-device-create built"

%:
	dh $@

override_dh_auto_clean:
	rm -fr .pc
	rm -f NVIDIA-Linux
	rm -fr $(foreach a,$(ARCH_LIST),NVIDIA-Linux-$a $(NVIDIA_DIRNAME_$a))
	rm -fr kernel-source-tree
	rm -f nvidia.ids nv-kernel.ids nv-readme.ids pci.ids.nvidia*
	rm -f debian/runtimepm_ids
	rm -f LICENSE.txt LICENSE.tmp copyright.tmp
	test ! -d debian/po || debconf-updatepo
	rm -f debian/$(pkg_driver).substvars
	rm -f debian/dkms.conf
	rm -f debian/device-create/ub-device-create

override_dh_clean: regen-from-templates
	dh_clean

override_dh_auto_configure: prepare regen-from-templates

override_dh_compress:
	dh_compress -Xsupported-gpus.json

override_dh_install: generate-modaliases build-device-create
	# Use our custom dkms.conf file
	cp -f $(CURDIR)/debian/dkms_nvidia.conf $(CURDIR)/debian/dkms.conf
	cp -f $(CURDIR)/debian/dkms_nvidia_open.conf $(CURDIR)/debian/open-kernel/dkms.conf

ifeq (,$(findstring nvidia-uvm,$(DKMS_disabled_modules)))
	# Make sure the UVM module is built
	cat $(CURDIR)/debian/dkms.conf.fragment >> $(CURDIR)/debian/dkms.conf
	cat $(CURDIR)/debian/dkms.conf.fragment >> $(CURDIR)/debian/open-kernel/dkms.conf
endif

	dh_install -p nvidia-compute-utils-$(version_major)
	mkdir -p $(CURDIR)/debian/nvidia-compute-utils-$(version_major)/lib/systemd
	dh_installsystemd --name=nvidia-persistenced
	dh_install -p nvidia-kernel-common-$(version_major)

	mkdir -p $(CURDIR)/debian/nvidia-kernel-common-$(version_major)/lib/systemd
	dh_installsystemd --name=nvidia-hibernate
	dh_installsystemd --name=nvidia-resume
	dh_installsystemd --name=nvidia-suspend

	dh_install

override_dh_installinit:
	dh_installinit --noscripts

override_dh_shlibdeps:
	LD_LIBRARY_PATH=/$(libdir):$(LD_LIBRARY_PATH) dh_shlibdeps

# Do not run dh_strip here.  The NVIDIA license says:
#
#     2.1.2 Linux/FreeBSD Exception.  Notwithstanding the foregoing terms of
#     Section 2.1.1, SOFTWARE designed exclusively for use on the Linux or
#     FreeBSD operating systems, or other operating systems derived from the
#     source code to these operating systems, may be copied and
#     redistributed, provided that the binary files thereof are not modified
#     in any way (except for unzipping of compressed files).
#
# Stripping the binary modules would constitute modifying the binary files
# in a way other than unzipping of compressed files.
override_dh_strip:
override_dh_strip_nondeterminism:

############################################################################

.PHONY: regen-from-templates
regen-from-templates:
	# Get rid of files belonging to different flavours
	for i in debian/templates/*.in; do \
		old=`echo $$i | sed -e "s|templates\/||g" | \
				sed -e "s|\.in\$$||g" | \
				sed -e "s|nvidia-graphics-drivers|nvidia-*|g" | \
				sed -e "s|version|*|g" | \
				sed -e "s|flavour|*|g"`; \
		rm -f $$old; done
	# Create important strings
	for i in debian/templates/*.in; do \
		dest=`echo $$i | sed -e "s|templates\/||g" | \
				 sed -e "s|\.in\$$||g" | \
				 sed -e "s|version|$(version)|g" | \
				 sed -e "s|flavour|$(flavour)|g"`; \
		sed -e "s|#LIBDIR#|$(libdir)|g"         \
			-e "s|#ARMHF_ONLY#|$(armhf_only)|g" \
			-e "s|#ARM64_ONLY#|$(arm64_only)|g" \
			-e "s|#AMD64_ONLY#|$(amd64_only)|g" \
			-e "s|#I386_ONLY#|$(i386_only)|g" \
			-e "s|#PPC64EL_ONLY#|$(ppc64el_only)|g" \
			-e "s|#ARMHF_EXCLUDED#|$(armhf_excluded)|g" \
			-e "s|#ARM64_EXCLUDED#|$(arm64_excluded)|g" \
			-e "s|#AMD64_EXCLUDED#|$(amd64_excluded)|g" \
			-e "s|#I386_EXCLUDED#|$(i386_excluded)|g" \
			-e "s|#PPC64EL_EXCLUDED#|$(ppc64el_excluded)|g" \
			-e "s|#NVEXCLUDEMODULES#|$(DKMS_disabled_modules)|g" \
			-e "s|#FLAVOUR#|$(flavour)|g" \
			-e "s|#DRIVERNAME#|$(pkg_driver)|g" \
			-e "s|#VERSION#|$(version)|g" \
			-e "s|#DEBIAN_VERSION#|$(debian_version)|g" \
			-e "s|#MODULENAME#|$(version)|g" \
			-e "s|#DEB_HOST_MULTIARCH#|$(DEB_HOST_MULTIARCH)|g" \
			$$i > $$dest;      \
	done

############################################################################

CACHE			?= ../.cache
ORIGDIR			?= nvidia-graphics-drivers-$(version_major).orig
TARBALL_BASE		?= nvidia-graphics-drivers-$(version_major)_$(NVIDIA_RELEASE).orig
TARBALL_SUFFIX		?= .tar.gz
TARBALL			?= $(TARBALL_BASE)$(TARBALL_SUFFIX)
ORIGDIR.empty		?= $(ORIGDIR)
TARBALL.empty		?= $(TARBALL)

# $1 = arch
get_download_url	 = $(or $(HTTPURL_PREFIX_$(strip $1)),$(HTTPURL_PREFIX))/$(HTTPURL_ARCHDIR_$(strip $1))/$(NVIDIA_RELEASE)/$(NVIDIA_FILENAME_$(strip $1))
get_origdir		 = $(or $(ORIGDIR.$(strip $1)),$(ORIGDIR)-$(strip $1))
get_tarball		 = $(or $(TARBALL.$(strip $1)),$(TARBALL_BASE)-$(strip $1)$(TARBALL_SUFFIX))

update-runtimepm-ids:
	python3 $(CURDIR)/debian/add-ids-to-json-db \
		NVIDIA-Linux/supported-gpus/supported-gpus.json \
		$(CURDIR)/debian/additional_runtimepm_ids \
		NVIDIA-Linux/supported-gpus/supported-gpus-mod.json

## nvidia-graphics-drivers-535 535.86.05

=== debian/changelog ===
nvidia-graphics-drivers-535 (535.86.05-0ubuntu0.23.04.1) lunar; urgency=medium

  * New upstream release (LP: #2028125):
    - Fixed a bug that caused excessive memory consumption when
      OpenGL and Vulkan applications were running while VT-
      switched away from X.
    - Fixed a bug that could cause the kernel to panic when video
      memory is full.
    - Fixed a bug that prevented displays from refreshing when using
      an NVIDIA PRIME Display Offload sink.
    - Fixed a bug that could cause some Variable Refresh Rate (VRR)
      monitors to flicker by allowing the refresh rate to drop below
      the monitor's minimum.
    - Fixed a bug that caused corruption when running Vulkan
      applications.
    - Fixed a regression that could cause a system hang when running
      windowed Vulkan applications with sync-to-vblank enabled.
    - Fixed a video memory leak observed when turning off a connected
      monitor while using certain Wayland compositors.
  * debian/rules{.defs}:
    - Match the patch changes on the Nvidia servers.

 -- Alberto Milone <alberto.milone@canonical.com>  Wed, 19 Jul 2023 09:08:42 +0000

nvidia-graphics-drivers-535 (535.54.03-0ubuntu0.23.04.2) lunar; urgency=medium

  * Correct typo in bug report reference (LP: #2024675).

 -- Alberto Milone <alberto.milone@canonical.com>  Wed, 28 Jun 2023 08:02:04 +0000

nvidia-graphics-drivers-535 (535.54.03-0ubuntu0.23.04.1) lunar; urgency=medium

  * Initial release (LP: ##2024675):
    - This replaces the 530 series.

 -- Alberto Milone <alberto.milone@canonical.com>  Mon, 26 Jun 2023 14:24:45 +0000

=== debian/control ===
--- 
+++ 
@@ -32,10 +32,10 @@
 Architecture: amd64 arm64
 Depends:
  libnvidia-gl-535 (= ${binary:Version}),
- nvidia-dkms-535 (<= 535.54.03-1),
- nvidia-dkms-535 (>= 535.54.03),
- nvidia-kernel-common-535 (<= 535.54.03-1),
- nvidia-kernel-common-535 (>= 535.54.03),
+ nvidia-dkms-535 (<= 535.86.05-1),
+ nvidia-dkms-535 (>= 535.86.05),
+ nvidia-kernel-common-535 (<= 535.86.05-1),
+ nvidia-kernel-common-535 (>= 535.86.05),
  nvidia-kernel-source-535 (= ${binary:Version}),
  libnvidia-compute-535 (= ${binary:Version}),
  libnvidia-extra-535 (= ${binary:Version}),
@@ -92,11 +92,11 @@
  nvidia-dkms-kernel
 Depends:
  dkms,
- nvidia-kernel-source-535 (<= 535.54.03-1),
- nvidia-kernel-source-535 (>= 535.54.03),
- nvidia-kernel-common-535 (<= 535.54.03-1),
- nvidia-kernel-common-535 (>= 535.54.03),
- nvidia-firmware-535-535.54.03,
+ nvidia-kernel-source-535 (<= 535.86.05-1),
+ nvidia-kernel-source-535 (>= 535.86.05),
+ nvidia-kernel-common-535 (<= 535.86.05-1),
+ nvidia-kernel-common-535 (>= 535.86.05),
+ nvidia-firmware-535-535.86.05,
  ${misc:Depends}, ${shlibs:Depends}
 Description: NVIDIA DKMS package
  This package builds the NVIDIA kernel module needed by the userspace
@@ -177,8 +177,8 @@
 Provides: nvidia-384
 Replaces: nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
 Depends:
- nvidia-kernel-common-535 (<= 535.54.03-1),
- nvidia-kernel-common-535 (>= 535.54.03),
+ nvidia-kernel-common-535 (<= 535.86.05-1),
+ nvidia-kernel-common-535 (>= 535.86.05),
  nvidia-kernel-source-535 (= ${binary:Version}),
  libnvidia-compute-535 (= ${binary:Version}),
  nvidia-compute-utils-535 (= ${binary:Version}),
@@ -215,7 +215,7 @@
 Conflicts: nvidia-kernel-common
 Provides: nvidia-kernel-common
 Depends:
- ${misc:Depends}, ${shlibs:Depends}, nvidia-firmware-535-535.54.03
+ ${misc:Depends}, ${shlibs:Depends}, nvidia-firmware-535-535.86.05
 Replaces:
  nvidia-dkms-535 (<< 390.48-0ubuntu3~), nvidia-kernel-common
 Description: Shared files used with the kernel module
@@ -226,7 +226,7 @@
  modules, and if you want udev to load the the NVIDIA kernel modules,
  and to create the uvm devices automatically.
 
-Package: nvidia-firmware-535-535.54.03
+Package: nvidia-firmware-535-535.86.05
 Architecture: amd64 arm64
 Depends:
  ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -238,12 +238,10 @@
 
 # $1 = arch
 get_download_url	 = $(or $(HTTPURL_PREFIX_$(strip $1)),$(HTTPURL_PREFIX))/$(HTTPURL_ARCHDIR_$(strip $1))/$(NVIDIA_RELEASE)/$(NVIDIA_FILENAME_$(strip $1))
+get_kern_download_url	= $(or $(HTTPURL_PREFIX_$(strip $1)),$(HTTPURL_PREFIX))/$(NVIDIA_FILENAME_$(strip $1))
 get_origdir		 = $(or $(ORIGDIR.$(strip $1)),$(ORIGDIR)-$(strip $1))
 get_tarball		 = $(or $(TARBALL.$(strip $1)),$(TARBALL_BASE)-$(strip $1)$(TARBALL_SUFFIX))
 
 update-runtimepm-ids:
 	python3 $(CURDIR)/debian/add-ids-to-json-db \
 		NVIDIA-Linux/supported-gpus/supported-gpus.json \
-		$(CURDIR)/debian/additional_runtimepm_ids \
-		NVIDIA-Linux/supported-gpus/supported-gpus-mod.json
-

## nvidia-graphics-drivers-535 535.104.05

=== debian/changelog ===
nvidia-graphics-drivers-535 (535.104.05-0ubuntu4) mantic; urgency=medium

  * debian/rules:
    - Do not start the systemd services on installation or upgrade, as this can
      lead to a black screen.

 -- Alberto Milone <alberto.milone@canonical.com>  Thu, 31 Aug 2023 09:06:31 +0000

nvidia-graphics-drivers-535 (535.104.05-0ubuntu3) mantic; urgency=medium

  * Revert switch to new metas for now.

 -- Alberto Milone <alberto.milone@canonical.com>  Mon, 28 Aug 2023 15:53:28 +0000

nvidia-graphics-drivers-535 (535.104.05-0ubuntu2) mantic; urgency=medium

  [ Dimitri John Ledkov ]
  * debian/rules add flavour like in server package
  * Add breaks&replaces on identical firmware files from other flavour
    (LP: #2026622)

 -- Alberto Milone <alberto.milone@canonical.com>  Tue, 22 Aug 2023 16:05:46 +0000

nvidia-graphics-drivers-535 (535.104.05-0ubuntu1) mantic; urgency=medium

  * New upstream release:
    - Fixed an issue which caused the following error message to
      appear spuriously when using SLI with the NVIDIA  Open GPU
      Kernel Modules:
      (EE) NVIDIA: Unable to disable FB size compare
    - Fixed a bug which prevented DKMS from registering kernel
      modules.
    - Fixed a bug which could cause the screen to flicker.

 -- Alberto Milone <alberto.milone@canonical.com>  Tue, 22 Aug 2023 15:17:24 +0000

nvidia-graphics-drivers-535 (535.98-0ubuntu1) mantic; urgency=medium

  * New upstream release:
    - Fixed a bug that caused excessive memory consumption when
      OpenGL and Vulkan applications were running while VT-
      switched away from X.
    - Fixed a bug that could cause the kernel to panic when video
      memory is full.
    - Fixed a bug that prevented displays from refreshing when using
      an NVIDIA PRIME Display Offload sink.
    - Fixed a bug that could cause some Variable Refresh Rate (VRR)
      monitors to flicker by allowing the refresh rate to drop below
      the monitor's minimum.
    - Fixed a bug that caused corruption when running Vulkan
      applications.
    - Fixed a regression that could cause a system hang when running
      windowed Vulkan applications with sync-to-vblank enabled.
    - Fixed a video memory leak observed when turning off a connected
      monitor while using certain Wayland compositors.
  * debian/rules:
    - Strip the binaries.
  * debian/template/control.in:
    - Introduce the new -core and -lrm meta-packages (LP: #2025538).
    - The nvidia-driver-$flavour package relies on DKMS, the
      nvidia-driver-lrm-$flavour is meant to be used with the
      linux-restricted module. They conflict with each other, and both
      depend on the nvidia-driver-core-$flavour meta-package.
  * debian/nvidia-driver-535.docs:
    - Rename to debian/nvidia-driver-core-535.docs.

 -- Alberto Milone <alberto.milone@canonical.com>  Mon, 14 Aug 2023 13:28:39 +0000

nvidia-graphics-drivers-535 (535.86.05-0ubuntu1) mantic; urgency=medium

  * New upstream release (LP: #2028125):
    - Fixed a bug that caused excessive memory consumption when
      OpenGL and Vulkan applications were running while VT-
      switched away from X.
    - Fixed a bug that could cause the kernel to panic when video
      memory is full.
    - Fixed a bug that prevented displays from refreshing when using
      an NVIDIA PRIME Display Offload sink.
    - Fixed a bug that could cause some Variable Refresh Rate (VRR)
      monitors to flicker by allowing the refresh rate to drop below
      the monitor's minimum.
    - Fixed a bug that caused corruption when running Vulkan
      applications.
    - Fixed a regression that could cause a system hang when running
      windowed Vulkan applications with sync-to-vblank enabled.
    - Fixed a video memory leak observed when turning off a connected
      monitor while using certain Wayland compositors.
  * debian/rules{.defs}:
    - Match the patch changes on the Nvidia servers.

 -- Alberto Milone <alberto.milone@canonical.com>  Wed, 19 Jul 2023 07:37:25 +0000

=== debian/control ===
--- 
+++ 
@@ -32,10 +32,10 @@
 Architecture: amd64 arm64
 Depends:
  libnvidia-gl-535 (= ${binary:Version}),
- nvidia-dkms-535 (<= 535.86.05-1),
- nvidia-dkms-535 (>= 535.86.05),
- nvidia-kernel-common-535 (<= 535.86.05-1),
- nvidia-kernel-common-535 (>= 535.86.05),
+ nvidia-dkms-535 (<= 535.104.05-1),
+ nvidia-dkms-535 (>= 535.104.05),
+ nvidia-kernel-common-535 (<= 535.104.05-1),
+ nvidia-kernel-common-535 (>= 535.104.05),
  nvidia-kernel-source-535 (= ${binary:Version}),
  libnvidia-compute-535 (= ${binary:Version}),
  libnvidia-extra-535 (= ${binary:Version}),
@@ -92,11 +92,11 @@
  nvidia-dkms-kernel
 Depends:
  dkms,
- nvidia-kernel-source-535 (<= 535.86.05-1),
- nvidia-kernel-source-535 (>= 535.86.05),
- nvidia-kernel-common-535 (<= 535.86.05-1),
- nvidia-kernel-common-535 (>= 535.86.05),
- nvidia-firmware-535-535.86.05,
+ nvidia-kernel-source-535 (<= 535.104.05-1),
+ nvidia-kernel-source-535 (>= 535.104.05),
+ nvidia-kernel-common-535 (<= 535.104.05-1),
+ nvidia-kernel-common-535 (>= 535.104.05),
+ nvidia-firmware-535-535.104.05,
  ${misc:Depends}, ${shlibs:Depends}
 Description: NVIDIA DKMS package
  This package builds the NVIDIA kernel module needed by the userspace
@@ -177,8 +177,8 @@
 Provides: nvidia-384
 Replaces: nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
 Depends:
- nvidia-kernel-common-535 (<= 535.86.05-1),
- nvidia-kernel-common-535 (>= 535.86.05),
+ nvidia-kernel-common-535 (<= 535.104.05-1),
+ nvidia-kernel-common-535 (>= 535.104.05),
  nvidia-kernel-source-535 (= ${binary:Version}),
  libnvidia-compute-535 (= ${binary:Version}),
  nvidia-compute-utils-535 (= ${binary:Version}),
@@ -215,7 +215,7 @@
 Conflicts: nvidia-kernel-common
 Provides: nvidia-kernel-common
 Depends:
- ${misc:Depends}, ${shlibs:Depends}, nvidia-firmware-535-535.86.05
+ ${misc:Depends}, ${shlibs:Depends}, nvidia-firmware-535-535.104.05
 Replaces:
  nvidia-dkms-535 (<< 390.48-0ubuntu3~), nvidia-kernel-common
 Description: Shared files used with the kernel module
@@ -226,8 +226,12 @@
  modules, and if you want udev to load the the NVIDIA kernel modules,
  and to create the uvm devices automatically.
 
-Package: nvidia-firmware-535-535.86.05
-Architecture: amd64 arm64
+Package: nvidia-firmware-535-535.104.05
+Architecture: amd64 arm64
+Breaks:
+ nvidia-firmware-535-server-535.104.05
+Replaces:
+ nvidia-firmware-535-server-535.104.05
 Depends:
  ${misc:Depends}
 Description: Firmware files used by the kernel module
@@ -340,10 +344,3 @@
 Pre-Depends:
  ${misc:Pre-Depends}
 Depends:
- libnvidia-compute-535 (= ${binary:Version}),
- ${shlibs:Depends}, ${misc:Depends}
-Conflicts:
- libnvidia-decode,
-Replaces:
- libnvidia-decode,
-Provides:

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,14 @@
 # system libdir
 libdir			?= usr/lib/$(DEB_HOST_MULTIARCH)
 
+last_suffix            := $(lastword $(subst -, ,$(DEB_SOURCE)))
+ifeq ($(last_suffix),server)
+flavour := $(version_major)-server
+other_flavour := $(version_major)
+else
 flavour := $(version_major)
+other_flavour := $(version_major)-server
+endif
 pkg_meta         := nvidia-driver-$(flavour)
 pkg_meta_open    := $(pkg_meta)-open
 pkg_driver       := nvidia-$(flavour)
@@ -157,13 +164,13 @@
 
 	dh_install -p nvidia-compute-utils-$(version_major)
 	mkdir -p $(CURDIR)/debian/nvidia-compute-utils-$(version_major)/lib/systemd
-	dh_installsystemd --name=nvidia-persistenced
+	dh_installsystemd --name=nvidia-persistenced --no-start
 	dh_install -p nvidia-kernel-common-$(version_major)
 
 	mkdir -p $(CURDIR)/debian/nvidia-kernel-common-$(version_major)/lib/systemd
-	dh_installsystemd --name=nvidia-hibernate
-	dh_installsystemd --name=nvidia-resume
-	dh_installsystemd --name=nvidia-suspend
+	dh_installsystemd --name=nvidia-hibernate --no-start
+	dh_installsystemd --name=nvidia-resume --no-start
+	dh_installsystemd --name=nvidia-suspend --no-start
 
 	dh_install
 
@@ -172,20 +179,6 @@
 
 override_dh_shlibdeps:
 	LD_LIBRARY_PATH=/$(libdir):$(LD_LIBRARY_PATH) dh_shlibdeps
-
-# Do not run dh_strip here.  The NVIDIA license says:
-#
-#     2.1.2 Linux/FreeBSD Exception.  Notwithstanding the foregoing terms of
-#     Section 2.1.1, SOFTWARE designed exclusively for use on the Linux or
-#     FreeBSD operating systems, or other operating systems derived from the
-#     source code to these operating systems, may be copied and
-#     redistributed, provided that the binary files thereof are not modified
-#     in any way (except for unzipping of compressed files).
-#
-# Stripping the binary modules would constitute modifying the binary files
-# in a way other than unzipping of compressed files.
-override_dh_strip:
-override_dh_strip_nondeterminism:
 
 ############################################################################
 
@@ -218,6 +211,7 @@
 			-e "s|#PPC64EL_EXCLUDED#|$(ppc64el_excluded)|g" \
 			-e "s|#NVEXCLUDEMODULES#|$(DKMS_disabled_modules)|g" \
 			-e "s|#FLAVOUR#|$(flavour)|g" \
+			-e "s|#OTHER_FLAVOUR#|$(other_flavour)|g" \
 			-e "s|#DRIVERNAME#|$(pkg_driver)|g" \
 			-e "s|#VERSION#|$(version)|g" \
 			-e "s|#DEBIAN_VERSION#|$(debian_version)|g" \
@@ -245,3 +239,12 @@
 update-runtimepm-ids:
 	python3 $(CURDIR)/debian/add-ids-to-json-db \
 		NVIDIA-Linux/supported-gpus/supported-gpus.json \
+		$(CURDIR)/debian/additional_runtimepm_ids \
+		NVIDIA-Linux/supported-gpus/supported-gpus-mod.json
+
+generate-runtimepm-aliases: update-runtimepm-ids
+	python3 $(CURDIR)/debian/pm-aliases-gen \
+		NVIDIA-Linux/supported-gpus/supported-gpus-mod.json > $(CURDIR)/debian/runtimepm_ids
+	rm -f NVIDIA-Linux/supported-gpus/supported-gpus-mod.json
+
+override_dh_gencontrol: generate-runtimepm-aliases

## nvidia-graphics-drivers-535 535.113.01

=== debian/changelog ===
nvidia-graphics-drivers-535 (535.113.01-0ubuntu3) mantic; urgency=medium

  * debian/rules:
    - Add override_dh_installsystemd.
    - Pass in dh_installsystemd --no-restart-after-upgrade.

 -- Alberto Milone <alberto.milone@canonical.com>  Fri, 29 Sep 2023 18:07:07 +0000

nvidia-graphics-drivers-535 (535.113.01-0ubuntu2) mantic; urgency=medium

  * debian/rules:
   - Pass in --no-stop-on-upgrade to dh_installsystemd.
     Prevent dh_installsystemd from stopping services (LP: #2025640).

 -- Alberto Milone <alberto.milone@canonical.com>  Fri, 29 Sep 2023 15:03:39 +0000

nvidia-graphics-drivers-535 (535.113.01-0ubuntu1) mantic; urgency=medium

  * New upstream release (LP: #2037266):
    - Fixed a bug that could cause GPU memory utilization to be
      reported incorrectly for Multi-Instance GPU (MIG) partitions on
      Grace Hopper systems.
    - Fixed a bug that intermittently caused the display to freeze
      when resuming from suspend on some Ada GPUs.

 -- Alberto Milone <alberto.milone@canonical.com>  Fri, 22 Sep 2023 10:44:17 +0000

=== debian/control ===
--- 
+++ 
@@ -32,10 +32,10 @@
 Architecture: amd64 arm64
 Depends:
  libnvidia-gl-535 (= ${binary:Version}),
- nvidia-dkms-535 (<= 535.104.05-1),
- nvidia-dkms-535 (>= 535.104.05),
- nvidia-kernel-common-535 (<= 535.104.05-1),
- nvidia-kernel-common-535 (>= 535.104.05),
+ nvidia-dkms-535 (<= 535.113.01-1),
+ nvidia-dkms-535 (>= 535.113.01),
+ nvidia-kernel-common-535 (<= 535.113.01-1),
+ nvidia-kernel-common-535 (>= 535.113.01),
  nvidia-kernel-source-535 (= ${binary:Version}),
  libnvidia-compute-535 (= ${binary:Version}),
  libnvidia-extra-535 (= ${binary:Version}),
@@ -92,11 +92,11 @@
  nvidia-dkms-kernel
 Depends:
  dkms,
- nvidia-kernel-source-535 (<= 535.104.05-1),
- nvidia-kernel-source-535 (>= 535.104.05),
- nvidia-kernel-common-535 (<= 535.104.05-1),
- nvidia-kernel-common-535 (>= 535.104.05),
- nvidia-firmware-535-535.104.05,
+ nvidia-kernel-source-535 (<= 535.113.01-1),
+ nvidia-kernel-source-535 (>= 535.113.01),
+ nvidia-kernel-common-535 (<= 535.113.01-1),
+ nvidia-kernel-common-535 (>= 535.113.01),
+ nvidia-firmware-535-535.113.01,
  ${misc:Depends}, ${shlibs:Depends}
 Description: NVIDIA DKMS package
  This package builds the NVIDIA kernel module needed by the userspace
@@ -177,8 +177,8 @@
 Provides: nvidia-384
 Replaces: nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
 Depends:
- nvidia-kernel-common-535 (<= 535.104.05-1),
- nvidia-kernel-common-535 (>= 535.104.05),
+ nvidia-kernel-common-535 (<= 535.113.01-1),
+ nvidia-kernel-common-535 (>= 535.113.01),
  nvidia-kernel-source-535 (= ${binary:Version}),
  libnvidia-compute-535 (= ${binary:Version}),
  nvidia-compute-utils-535 (= ${binary:Version}),
@@ -215,7 +215,7 @@
 Conflicts: nvidia-kernel-common
 Provides: nvidia-kernel-common
 Depends:
- ${misc:Depends}, ${shlibs:Depends}, nvidia-firmware-535-535.104.05
+ ${misc:Depends}, ${shlibs:Depends}, nvidia-firmware-535-535.113.01
 Replaces:
  nvidia-dkms-535 (<< 390.48-0ubuntu3~), nvidia-kernel-common
 Description: Shared files used with the kernel module
@@ -226,12 +226,12 @@
  modules, and if you want udev to load the the NVIDIA kernel modules,
  and to create the uvm devices automatically.
 
-Package: nvidia-firmware-535-535.104.05
+Package: nvidia-firmware-535-535.113.01
 Architecture: amd64 arm64
 Breaks:
- nvidia-firmware-535-server-535.104.05
-Replaces:
- nvidia-firmware-535-server-535.104.05
+ nvidia-firmware-535-server-535.113.01
+Replaces:
+ nvidia-firmware-535-server-535.113.01
 Depends:
  ${misc:Depends}
 Description: Firmware files used by the kernel module

=== debian/rules ===
--- 
+++ 
@@ -164,13 +164,13 @@
 
 	dh_install -p nvidia-compute-utils-$(version_major)
 	mkdir -p $(CURDIR)/debian/nvidia-compute-utils-$(version_major)/lib/systemd
-	dh_installsystemd --name=nvidia-persistenced --no-start
+	dh_installsystemd --name=nvidia-persistenced --no-start --no-stop-on-upgrade --no-restart-after-upgrade
 	dh_install -p nvidia-kernel-common-$(version_major)
 
 	mkdir -p $(CURDIR)/debian/nvidia-kernel-common-$(version_major)/lib/systemd
-	dh_installsystemd --name=nvidia-hibernate --no-start
-	dh_installsystemd --name=nvidia-resume --no-start
-	dh_installsystemd --name=nvidia-suspend --no-start
+	dh_installsystemd --name=nvidia-hibernate --no-start --no-stop-on-upgrade --no-restart-after-upgrade
+	dh_installsystemd --name=nvidia-resume --no-start --no-stop-on-upgrade --no-restart-after-upgrade
+	dh_installsystemd --name=nvidia-suspend --no-start --no-stop-on-upgrade --no-restart-after-upgrade
 
 	dh_install
 
@@ -179,6 +179,8 @@
 
 override_dh_shlibdeps:
 	LD_LIBRARY_PATH=/$(libdir):$(LD_LIBRARY_PATH) dh_shlibdeps
+
+override_dh_installsystemd:
 
 ############################################################################
 
@@ -243,8 +245,3 @@
 		NVIDIA-Linux/supported-gpus/supported-gpus-mod.json
 
 generate-runtimepm-aliases: update-runtimepm-ids
-	python3 $(CURDIR)/debian/pm-aliases-gen \
-		NVIDIA-Linux/supported-gpus/supported-gpus-mod.json > $(CURDIR)/debian/runtimepm_ids
-	rm -f NVIDIA-Linux/supported-gpus/supported-gpus-mod.json
-
-override_dh_gencontrol: generate-runtimepm-aliases
